// Generated by CoffeeScript 2.3.1
(function() {
  var debug, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:carrier:ingress:send`;

  debug = (require('tangible'))(this.name);

  // Send a call out using carrier-side rules.
  this.include = async function() {
    var base, cause, data, ingress_target, ref, ref1, res;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'ingress') {
      return;
    }
    this.debug('Ready');
    ({ingress_target} = this.session.profile_data);
    this.debug('bridge', {
      sip_profile: this.session.sip_profile,
      destination: this.destination,
      ingress_target: ingress_target
    });
    res = (await this.action('bridge', `sofia/${this.session.sip_profile}/sip:${this.destination}@${ingress_target}`));
    data = res.body;
    if ((base = this.session).bridge_data == null) {
      base.bridge_data = [];
    }
    this.session.bridge_data.push(data);
    this.debug('FreeSwitch response', res);
    cause = (ref1 = data != null ? data.variable_last_bridge_hangup_cause : void 0) != null ? ref1 : data != null ? data.variable_originate_disposition : void 0;
    this.debug('Cause', cause);
    if (cause === 'NORMAL_CALL_CLEARING' || cause === 'SUCCESS') {
      return this.debug(`Successful call when routing ${this.destination} through ${ingress_target}`);
    } else {
      return this.debug(`Call failed: ${cause} when routing ${this.destination} through ${ingress_target}`);
    }
  };

}).call(this);
