// Generated by CoffeeScript 2.3.1
(function() {
  var Moment, debug, foot, pkg,
    hasProp = {}.hasOwnProperty;

  pkg = require('../package.json');

  this.name = `${pkg.name}:middleware:cdr`;

  ({debug, foot} = (require('tangible'))(this.name));

  Moment = require('moment-timezone');

  this.include = async function() {
    var call_data;
    call_data = {};
    // The time we started processing this call.
    call_data.start_time = Date.now();
    // The call UUID (managed by FreeSwitch).
    call_data.uuid = this.call.uuid;
    // The session ID (managed by `tangible/middleware`).
    call_data.session = this.session._id;
    // A record of the (original, pre-processing) source and destination.
    call_data.source = this.source;
    call_data.destination = this.destination;
    // Replacement for `esl/src/esl:auto_cleanup`'s `freeswitch_linger` handler.
    this.call.once('cleanup_linger', foot(async() => {
      debug("CDR: Linger: pausing");
      await this.sleep(4000);
      debug("CDR: Linger: exit");
      await this.call.exit();
      this.end();
    }));
    await this.call.linger();
    if (!((this.statistics != null) && (this.notify != null))) {
      this.debug.dev('Error: Improper environment');
      return;
    }
    this.statistics.add('incoming-calls');
    await this.call.event_json('CHANNEL_HANGUP_COMPLETE');
    this.call.once('CHANNEL_HANGUP_COMPLETE', foot(async(res) => {
      var cdr_report, data, float, integer, k, ref, ref1, ref2, ref3, uepoch, v;
      debug("Channel Hangup Complete");
      // * session.cdr_direction (string) original call direction, before it is modified for example into `lcr` or `voicemail`.
      data = res.body;
      integer = function(x) {
        var v;
        if (isNaN(v = parseInt(x, 10))) {
          return null;
        }
        return v;
      };
      float = function(x) {
        var v;
        if (isNaN(v = parseFloat(x))) {
          return null;
        }
        return v;
      };
      uepoch = function(x) {
        var v;
        if (isNaN(v = parseInt(x, 10))) {
          return null;
        }
        return Math.floor(v / 1000);
      };
      cdr_report = {
        direction: this.session.cdr_direction,
        emergency: (ref = this.session.destination_emergency) != null ? ref : null,
        onnet: (ref1 = this.session.destination_onnet) != null ? ref1 : null,
        duration: integer(data.variable_mduration),
        billable: integer(data.variable_billmsec),
        progress: integer(data.variable_progressmsec),
        answer: integer(data.variable_answermsec),
        wait: integer(data.variable_waitmsec),
        held: integer(data.variable_hold_accum_ms),
        progress_media: integer(data.variable_progress_mediamsec),
        flow_bill: integer(data.variable_flow_billmsec),
        start_time: uepoch(data.variable_start_uepoch),
        answer_time: uepoch(data.variable_answer_uepoch),
        bridge_time: uepoch(data.variable_bridge_uepoch),
        progress_time: uepoch(data.variable_progress_uepoch),
        // even-numbered are hold 'on', odd-numbered are hold 'off'
        hold_times: (ref2 = (ref3 = data.variable_hold_events) != null ? ref3.match(/(\d+)/g).map(uepoch) : void 0) != null ? ref2 : [],
        end_time: uepoch(data.variable_end_uepoch),
        audio_in_packets: integer(data.rtp_audio_in_packet_count),
        audio_out_packets: integer(data.rtp_audio_out_packet_count),
        skip_packets: integer(data.variable_rtp_audio_in_skip_packet_count),
        jitter_packets: integer(data.variable_rtp_audio_in_jitter_packet_count),
        jitter_min_variance: float(data.variable_rtp_audio_in_jitter_min_variance),
        jitter_max_variance: float(data.variable_rtp_audio_in_jitter_max_variance),
        in_mos: float(data.variable_rtp_audio_in_mos)
      };
      for (k in cdr_report) {
        if (!hasProp.call(cdr_report, k)) continue;
        v = cdr_report[k];
        switch (k) {
          case 'direction':
            this.statistics.add(`direction-${v}`, cdr_report.billable);
            break;
          case 'emergency':
            if (v) {
              this.statistics.add("emergency");
            }
            break;
          case 'onnet':
            if (v) {
              this.statistics.add("onnet");
            }
            break;
          case 'hold_times':
          case 'end_time':
          case 'start_time':
          case 'answer_time':
          case 'bridge_time':
          case 'progress_time':
            false;
            break;
          default:
            this.statistics.add(k, v);
        }
      }
      this.session.cdr_report = cdr_report;
      this.emit('cdr_report', cdr_report);
      // Update the (existing) call data
      call_data.end_time = Date.now();
      if (this.session.timezone != null) {
        call_data.timezone = this.session.timezone;
        call_data.tz_start_time = Moment(call_data.start_time).tz(this.session.timezone).format();
        call_data.tz_end_time = Moment(call_data.end_time).tz(this.session.timezone).format();
      }
      await this.notify({
        state: 'end',
        call_data,
        cdr_report
      });
      debug("CDR: Channel Hangup Complete", cdr_report);
    }));
    this.debug('Ready');
  };

}).call(this);
