// Generated by CoffeeScript 2.3.1
(function() {
  var pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:egress:centrex-FR`;

  this.include = async function() {
    var m, ref, ref1, ref2, ref3, ref4, ref5;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    if (this.session.country !== 'fr') {
      return;
    }
    this.debug('Start', this.destination);
    this.session.centrex_external_line_prefix = '9';
    this.session.VOICEMAIL = '786';
    switch (false) {
      // Internal call: ring the phone, apply cfa/cfb/cfda/cfnr if applicable.
      // Keep @session.dialplan.
      case !this.destination.match(/^[1-6]\d+$/):
        this.debug('Internal call');
        await this.action('privacy', 'no');
        this.session.centrex_internal = true;
        this.session.sip_profile = this.session.sip_profile_client;
        this.direction('ingress');
        this.session.cdr_direction = 'centrex-internal';
        break;
      // External call.
      // For Centrex we use `asserted` as `egress calling number`, and only use it for external calls.
      // Keep @session.direction and @session.country.
      case !(this.destination[0] === this.session.centrex_external_line_prefix && (m = this.destination.match(/^\d(\d+)$/))):
        this.debug('External call');
        this.session.dialplan = 'national';
        this.destination = m[1];
        this.source = (ref1 = (ref2 = this.session.asserted) != null ? ref2 : this.session.number.asserted) != null ? ref1 : this.source;
        this.debug('External call', {source: this.source, destination: this.destination});
        break;
      case this.destination[0] !== '+':
        this.session.dialplan = 'national';
        this.source = (ref3 = (ref4 = this.session.asserted) != null ? ref4 : this.session.number.asserted) != null ? ref3 : this.source;
        this.debug('External call', {source: this.source, destination: this.destination});
        break;
      // Voicemail.
      case (ref5 = this.destination) !== 'vm' && ref5 !== 'voicemail' && ref5 !== '*86' && ref5 !== '786':
        this.debug('Voicemail');
        this.destination = 'inbox';
        this.direction('voicemail');
    }
  };

}).call(this);
