// Generated by CoffeeScript 2.3.1
(function() {
  var Unique_ID, debug, default_eavesdrop_timeout, hand, heal, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:egress:centrex-redirect`;

  ({debug, hand, heal} = (require('tangible'))(this.name));

  Unique_ID = 'Unique-ID';

  default_eavesdrop_timeout = 8 * 3600; // 8h

  this.include = async function() {
    var eavesdrop_key, eavesdrop_timeout, is_remote, key, queuer, queuer_call, ref, ref1, res, server, uri;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    // Transfer Workaround
    // -------------------
    is_remote = (await this.cfg.is_remote(this.session.number_domain, [this.session.local_server, this.session.client_server].join('/')));
    if (is_remote) {
      server = is_remote.split('/')[1];
      this.report({
        state: 'centrex-redirect',
        server
      });
      uri = `<sip:${this.destination}@${server};xref=${this.session.reference}>`;
      this.debug('Handling is remote', uri);
      // Send a REFER to a call which is already answered. (Typically, coming from `exultant-songs`.)
      if (this.data['Answer-State'] === 'answered') {
        uri = `<sip:${this.destination}@${this.session.number_domain};xref=${this.session.reference}?Via=${server}>`;
        res = (await this.action('deflect', uri));
      } else {
        // For an unanswered call (the default/normal behavior for a call coming from a phone),
        // send a 302 back to OpenSIPS; OpenSIPS interprets the 302 and submits to the remote server.
        res = (await this.action('redirect', uri));
      }
      this.debug('Redirection returned', uri, res);
      // Make sure there is no further processing.
      this.direction('transferred');
      return;
    }
    // Centrex Handling
    // ----------------
    this.debug('Handling is local');
    // Eavesdrop registration
    // ----------------------
    ({eavesdrop_timeout} = this.cfg);
    if (eavesdrop_timeout == null) {
      eavesdrop_timeout = default_eavesdrop_timeout;
    }
    key = this.session.agent;
    eavesdrop_key = `outbound:${key}`;
    ({queuer} = this.cfg);
    if (!this.call.closed) {
      this.debug('Set outbound eavesdrop', eavesdrop_key);
      await ((ref1 = this.local_redis) != null ? ref1.setex(eavesdrop_key, eavesdrop_timeout, this.call.uuid) : void 0);
      debug('CHANNEL_PRESENT', key, this.call.uuid);
      // Bind the agent to the call.
      if ((queuer != null) && (this.queuer_call != null)) {
        queuer_call = (await this.queuer_call());
        await queuer.set_agent(queuer_call, key);
      }
      this.report({
        event: 'start-of-call',
        agent: key,
        call: this.call.uuid
      });
    }
    return this.debug('Ready');
  };

}).call(this);
