// Generated by CoffeeScript 2.3.1
(function() {
  var debug, hostname, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:forward:basic`;

  debug = (require('tangible'))(this.name);

  ({hostname} = require('os'));

  this.include = async function() {
    var ref, ref1;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'forward') {
      return;
    }
    this.report({
      state: 'forward'
    });
    this.debug('forwarding on behalf of', this.session.endpoint_name);
    this.session.endpoint = (await this.cfg.prov.get(`endpoint:${this.session.endpoint_name}`));
    this.session.outbound_route = this.session.endpoint.outbound_route;
    this.session.forwarding = true;
    if (this.cfg.mask_source_on_forward) {
      this.session.source = this.source;
      this.source = this.destination;
    }
    this.destination = this.session.destination;
    this.direction('egress');
    // await @reference.add_in @session.endpoint._id
    await this.user_tags(this.session.endpoint.tags);
    // FIXME the original URI part should be the Request-URI per RFC5806
    await this.export({
      sip_h_Diversion: `<sip:${this.destination}@${(ref1 = this.cfg.host) != null ? ref1 : hostname()}>;reason=${this.session.reason}`
    });
    this.report({
      state: 'pre-forward',
      endpoint: this.session.endpoint._id
    });
    this.debug('OK', {
      'session.outbound_route': this.session.outbound_route,
      'session.direction': this.session.direction,
      'session.forwarding': this.session.forwarding,
      'session.source': this.session.source,
      'source': this.source,
      'destination': this.destination
    });
  };

}).call(this);
