// Generated by CoffeeScript 2.3.1
(function() {
  var FS, Moment, RedisInterface, SUBSCRIBE, TaggedAgent, TaggedCall, debug, domain_of, foot, monitor, now, pkg, queuer, request, run, sleep,
    hasProp = {}.hasOwnProperty;

  this.name = 'huge-play:middleware:client:queuer';

  ({debug, foot} = (require('tangible'))(this.name));

  pkg = {
    name: 'huge-play'
  };

  Moment = require('moment-timezone');

  ({SUBSCRIBE} = require('red-rings/operations'));

  queuer = require('black-metal/queuer');

  request = require('superagent');

  run = require('flat-ornament');

  sleep = function(timeout) {
    return new Promise(function(resolve) {
      return setTimeout(resolve, timeout);
    });
  };

  domain_of = function(key) {
    return key != null ? key.split('@')[1] : void 0;
  };

  now = function(tz = 'UTC') {
    return Moment().tz(tz).format();
  };

  ({TaggedCall, TaggedAgent} = require('black-metal/tagged'));

  monitor = require('screeching-eggs/monitor');

  FS = require('esl');

  RedisInterface = require('normal-key/interface');

  // DEPRECATED
  this.notify = function() {
    var Agent, get_pool, host;
    ({host} = this.cfg);
    if (this.cfg.queuer == null) {
      debug.dev('queuer is not available');
      return;
    }
    ({Agent} = this.cfg.queuer);
    if (Agent == null) {
      debug.dev('Agent is not available');
      return;
    }
    this.configure({
      dial_calls: true
    });
    // Events received downstream.
    this.register('queuer:get-agent-state', 'dial_calls');
    this.register('queuer:log-agent-out', 'dial_calls');
    this.register('queuer:log-agent-in', 'dial_calls');
    this.socket.on('queuer:get-agent-state', foot(async(key) => {
      var agent, is_remote, state;
      is_remote = (await this.cfg.is_remote(domain_of(key)));
      if (is_remote !== false) {
        return;
      }
      debug('queuer:get-agent-state', key);
      agent = new Agent(key);
      state = (await agent.state().catch(function() {
        return null;
      }));
      // async
      agent.notify({state});
      debug('queuer:get-agent-state: done', key, state);
    }));
    this.socket.on('queuer:log-agent-out', foot(async(key) => {
      var agent, is_remote;
      is_remote = (await this.cfg.is_remote(domain_of(key)));
      if (is_remote !== false) {
        return;
      }
      debug('queue:log-agent-out', key);
      agent = new Agent(key);
      await agent.clear_tags();
      await agent.transition('logout');
      debug('queue:log-agent-out: done', key);
    }));
    this.socket.on('queuer:log-agent-in', foot(async(key) => {
      var agent, broadcast, ctx, i, is_remote, j, len, len1, queue, queues, skill, skills, tags, timezone;
      is_remote = (await this.cfg.is_remote(domain_of(key)));
      if (is_remote !== false) {
        return;
      }
      debug('queue:log-agent-in', key);
      tags = [];
      ({skills, queues, broadcast, timezone} = (await this.cfg.prov.get(`number:${key}`)));
      if (skills != null) {
        for (i = 0, len = skills.length; i < len; i++) {
          skill = skills[i];
          tags.push(`skill:${skill}`);
        }
      }
      if (queues != null) {
        for (j = 0, len1 = queues.length; j < len1; j++) {
          queue = queues[j];
          tags.push(`queue:${queue}`);
        }
      }
      if (broadcast) {
        tags.push('broadcast');
      }
      agent = new Agent(key);
      await agent.add_tags(tags);
      if (typeof ornaments !== "undefined" && ornaments !== null) {
        ctx = {agent, timezone};
        await run.call(ctx, ornaments, this.ornaments_commands);
      }
      await agent.accept_onhook();
      await this.report({
        state: 'queuer-login',
        source,
        fifo,
        tags
      });
      debug('queue:log-agent-in: done', key);
    }));
    // Downstream/upstream pair for egress/ingress-pool retrieval.
    get_pool = (name, pool) => {
      this.register(`queuer:get-${name}-pool`, 'dial_calls');
      this.register(`queuer:${name}-pool`, 'calls');
      return this.socket.on(`queuer:get-${name}-pool`, foot(async(domain) => {
        var calls, is_remote, notification, result;
        debug(`queuer:get-${name}-pool`, domain);
        is_remote = (await this.cfg.is_remote(domain));
        if (is_remote !== false) {
          return;
        }
        calls = (await pool(domain).calls());
        result = (await Promise.all(calls.map(function(call) {
          return call.build_notification({});
        })));
        notification = {
          _queuer: true,
          host: host,
          now: Date.now(),
          _in: [`number_domain:${domain}`],
          calls: result
        };
        this.socket.emit(`queuer:${name}-pool`, notification);
        debug(`queuer:get-${name}-pool: done`, domain, notification);
      }));
    };
    get_pool('egress', (domain) => {
      return this.cfg.queuer.egress_pool(domain);
    });
    return get_pool('ingress', (domain) => {
      return this.cfg.queuer.ingress_pool(domain);
    });
  };

  // /DEPRECATED
  this.server_pre = function() {
    var HugePlayAgent, HugePlayCall, HugePlayReference, Queuer, agent_timeout, api, call_timeout, cfg, client, host, options, p, pools_redis_interface, port, profile, prov, ref, ref1, ref2, ref3, ref4;
    cfg = this.cfg;
    cfg.rr.receive('agent:*').forEach(async function(msg) {
      var $, agent, broadcast, ctx, i, is_remote, j, key, len, len1, queue, queues, ref, ref1, skill, skills, state, tags, timezone;
      switch (false) {
        case msg.op !== SUBSCRIBE:
          // get agent state
          if (!($ = (ref = msg.key) != null ? ref.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = (await cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          debug('queuer:get-agent-state', key);
          agent = new Agent(key);
          state = (await agent.state().catch(function() {
            return null;
          }));
          await agent.notify({state});
          break;
        case msg.op !== UPDATE:
          // log agent in or out; use redring.create() for login, redring.delete() for logout
          if (!($ = (ref1 = msg.id) != null ? ref1.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = (await cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          if (msg.deleted) {
            debug('queue:log-agent-out', key);
            agent = new Agent(key);
            await agent.clear_tags();
            await agent.transition('logout');
          } else {
            tags = [];
            ({skills, queues, broadcast, timezone} = (await cfg.prov.get(`number:${key}`)));
            if (skills != null) {
              for (i = 0, len = skills.length; i < len; i++) {
                skill = skills[i];
                tags.push(`skill:${skill}`);
              }
            }
            if (queues != null) {
              for (j = 0, len1 = queues.length; j < len1; j++) {
                queue = queues[j];
                tags.push(`queue:${queue}`);
              }
            }
            if (broadcast) {
              tags.push('broadcast');
            }
            agent = new Agent(key);
            await agent.add_tags(tags);
            if (typeof ornaments !== "undefined" && ornaments !== null) {
              ctx = {agent, timezone};
              await run.call(ctx, ornaments, this.ornaments_commands);
            }
            await agent.accept_onhook();
          }
      }
    });
    cfg.rr.receive('pool:*').filter(function({op}) {
      return op === SUBSCRIBE;
    }).forEach(async function(msg) {
      var $, calls, domain, is_remote, name, notification, ref, result;
      if (!($ = (ref = msg.key) != null ? ref.match(/^pool:(\S+):(ingress|egress)$/) : void 0)) {
        return;
      }
      domain = $[1];
      name = $[2];
      is_remote = (await cfg.is_remote(domain));
      if (is_remote !== false) {
        return;
      }
      calls = (await pool(domain).calls());
      result = (await Promise.all(calls.map(function(call) {
        return call.build_notification({});
      })));
      notification = {
        host: host,
        now: Date.now(),
        calls: result
      };
      cfg.rr.notify(msg.key, `number_domain:${domain}`, value);
    });
    HugePlayReference = this.cfg.Reference;
    ({api, prov, host} = this.cfg);
    profile = (ref = this.cfg.session) != null ? ref.profile : void 0;
    p = (ref1 = this.cfg.profiles) != null ? ref1[profile] : void 0;
    if (p != null) {
      port = (ref2 = p.egress_sip_port) != null ? ref2 : p.sip_port + 10000;
    }
    if (!((cfg.local_redis_client != null) && (prov != null) && (profile != null) && (host != null) && (port != null) && (api != null) && (HugePlayReference != null))) {
      this.debug.dev('Missing configuration');
      return;
    }
    // How long should we keep the state of a call after the last update?
    call_timeout = 8 * 3600;
    // How long should we keep the state of an agent after the last update?
    agent_timeout = 12 * 3600;
    HugePlayCall = (function() {
      class HugePlayCall extends TaggedCall {
        async build_notification(data) {
          var k, notification, v;
          notification = {
            _queuer: true,
            host: host,
            now: Date.now(),
            domain: this.domain,
            key: this.key,
            id: this.id,
            destination: this.destination,
            call_state: (await this.state().catch(function() {
              return null;
            })),
            remote_number: (await this.get_remote_number().catch(function() {
              return null;
            })),
            alert_info: (await this.get_alert_info().catch(function() {
              return null;
            })),
            reference: (await this.get_reference().catch(function() {
              return null;
            })),
            session: (await this.get_session().catch(function() {
              return null;
            })),
            answered: (await this.answered().catch(function() {
              return null;
            })),
            presenting: (await this.count().catch(function() {
              return null;
            })),
            tags: (await this.tags().catch(function() {
              return [];
            }))
          };
          for (k in data) {
            if (!hasProp.call(data, k)) continue;
            v = data[k];
            if (!(v != null)) {
              continue;
            }
            switch (k) {
              case 'agent':
              case 'call':
              case 'agent_call':
              case 'remote_call':
                if (typeof v !== 'string') {
                  v = v.key;
                }
            }
            if (notification[k] == null) {
              notification[k] = v;
            }
          }
          return notification;
        }

        async notify(data) {
          var notification;
          debug('call.report', data);
          notification = (await this.build_notification(data));
          cfg.statistics.emit('queuer', notification); // DEPRECATED
          cfg.rr.notify(`call:${notification.id}`, `call:${notification.id}`, notification);
          debug('call.report: send', notification);
          return notification;
        }

      };

      HugePlayCall.prototype.interface = new RedisInterface(cfg.local_redis_client, call_timeout);

      HugePlayCall.prototype.__api = api;

      HugePlayCall.prototype.profile = `${pkg.name}-${profile}-egress`;

      HugePlayCall.prototype.Reference = HugePlayReference;

      return HugePlayCall;

    }).call(this);
    HugePlayAgent = (function() {
      class HugePlayAgent extends TaggedAgent {
        async notify(data) {
          var agent_name, event, notification, offhook, old_state, reason, state;
          debug('agent.notify', this.key, data);
          ({old_state, state, event, reason} = data);
          notification = {
            _queuer: true,
            _in: [`endpoint:${this.key}`, `number:${this.key}`, `number_domain:${this.domain}`],
            _notify: true,
            host: host,
            now: Date.now(),
            state: state,
            old_state: old_state,
            event: event,
            reason: reason,
            agent: this.key,
            number: this.number,
            number_domain: this.domain,
            // The dialplan is used e.g. to know which messages to forward to the socket.io bus.
            dialplan: 'centrex',
            missed: (await this.get_missed().catch(function() {
              return 0;
            })),
            count: (await this.count().catch(function() {
              return 0;
            }))
          };
          notification.tags = (await this.tags().catch(function() {
            return [];
          }));
          agent_name = (await (this.get('name')).catch(function() {
            return null;
          }));
          if (agent_name != null) {
            notification.agent_name = agent_name;
          }
          offhook = (await this.get_offhook_call().catch(function() {
            return null;
          }));
          if (offhook) {
            notification.offhook = true;
          } else {
            notification.offhook = false;
          }
          // Module `black-metal` 8.3.0 will report the call object as `data.call` (and this is currently the only parameter that might be provided).

          // If `data.call` is present we notify using the call's process; if it isn't we notify directly.
          // This avoids sending two messages for the same event (one with incomplete data, the other with complete data).
          if (data.call != null) {
            notification = (await data.call.report(notification));
          } else {
            cfg.statistics.emit('queuer', notification); // DEPRECATED
          }
          cfg.rr.notify(`agent:${notification.agent}`, `agent:${notification.agent}`, notification);
          debug('agent.notify: done', this.key, notification);
        }

        async create_egress_call(body) {
          var _id, account, call, call_data, endpoint, options, queuer_webhook, reference, tags, timezone;
          debug('create_egress_call', this.domain, body);
          if (this.number_domain_data == null) {
            this.number_domain_data = (await prov.get(`number_domain:${this.domain}`).catch(function(error) {
              return null;
            }));
          }
          if (this.number_domain_data == null) {
            debug('create_egress_call: missing number-domain', this.domain);
            return;
          }
          ({account, queuer_webhook, timezone} = this.number_domain_data);
          if (timezone == null) {
            timezone = null;
          }
          await this.set('timezone', timezone);
          if (account == null) {
            debug('create_egress_call: no account', this.domain);
            return null;
          }
          if (body == null) {
            if (queuer_webhook == null) {
              debug('create_egress_call: no queuer_webhook', this.domain);
              return null;
            }
            tags = (await this.tags());
            options = {key: this.key, number: this.number, domain: this.domain, tags};
            debug('create_egress_call: send request', options);
            ({body} = (await request.post(queuer_webhook).send(options)));
          }
          if (body.tags == null) {
            body.tags = [];
          }
          if (!((body.destination != null) && (body.tags != null) && (body.tags.length != null))) {
            debug('create_egress_call: incomplete response', this.domain, body);
            return null;
          }
          body.tags.push('queuer');
          debug('create_egress_call: creating call', this.domain, body);
          body.tags.push('egress');
          // See `in_domain` in black-metal/tagged.
          body.tags.push(`number_domain:${this.domain}`);
          endpoint = this.key;
          reference = new HugePlayReference();
          _id = reference.id;
          // FIXME This is highly inefficient, we should be able to create the structure at once.
          await reference.add_in([
            `endpoint:${endpoint}`,
            `number:${endpoint // Centrex-only
}`,
            `account:${account}`,
            `number_domain:${this.domain}`
          ]);
          await reference.set_endpoint(endpoint);
          await reference.set_account(account);
          await reference.set_destination(body.destination);
          await reference.set_source(this.number);
          await reference.set_domain(`${host}:${port}`);
          // await reference.set_tags body.tags # set_tags = clear_tags() + add_tags()
          await reference.set_block_dtmf(true);
          // This is a "fake" call-data entry, to record the data we used to trigger the call for call-reporting purposes.
          call_data = {
            uuid: 'create-egress-call',
            session: `${_id}-create-egress-call`,
            reference: _id,
            start_time: now(timezone),
            source: this.number,
            destination: body.destination,
            timezone: timezone,
            timestamp: now(timezone),
            host: host,
            type: 'call',
            event: 'create-egress-call'
          };
          call = new Call(make_id());
          await call.set_domain(this.domain);
          await call.set_started_at();
          await call.set_destination(_id); // destination endpoint
          
          // This probably not necessary, since the destination number is actually retrieved from the reference-data.
          await call.set_remote_number(body.destination);
          await call.set_tags(body.tags);
          await call.set('timezone', timezone);
          // async
          this.notify(call_data);
          debug('create_egress_call: complete');
          return call;
        }

      };

      HugePlayAgent.prototype.interface = new RedisInterface(cfg.local_redis_client, agent_timeout);

      return HugePlayAgent;

    }).call(this);
    // #The queuer's Redis is used for call pools and the agents pool.
    // #Since we're bound to a server for domains it's OK to use the local Redis.
    pools_redis_interface = new RedisInterface(cfg.local_redis_client, agent_timeout);
    Queuer = queuer(pools_redis_interface, {
      Agent: HugePlayAgent,
      Call: HugePlayCall
    });
    this.cfg.queuer = new Queuer(this.cfg);
    options = {
      host: (ref3 = this.cfg.socket_host) != null ? ref3 : '127.0.0.1',
      port: (ref4 = this.cfg.socket_port) != null ? ref4 : 5722
    };
    client = FS.createClient(options);
    monitor(client, this.cfg.queuer.Call);
  };

  // Middleware
  // ==========
  this.include = async function() {
    var Agent, Call, local_server, uuid;
    if ((await this.reference.get_block_dtmf())) {
      await this.action('block_dtmf');
    }
    queuer = this.cfg.queuer;
    if (queuer == null) {
      return;
    }
    ({Agent, Call} = this.cfg.queuer);
    if (!((Agent != null) && (Call != null))) {
      return;
    }
    // Queuer Call object
    // ------------------
    ({uuid} = this.call);
    this.queuer_call = async function(id) {
      var domain, queuer_call;
      domain = this.session.number_domain;
      if (id == null) {
        id = uuid;
      }
      this.debug('queuer_call', id, domain);
      queuer_call = new Call(id);
      await queuer_call.set_domain(domain);
      await queuer_call.set_started_at();
      await queuer_call.set_id(id);
      await queuer_call.set_session(this.session._id);
      await queuer_call.set_reference(this.session.reference);
      return queuer_call;
    };
    // Agent state monitoring
    // ----------------------
    local_server = [this.session.local_server, this.session.client_server].join('/');
    // On-hook agent
    // -------------
    this.queuer_login = async function(source, name, fifo, tags = [], ornaments) {
      var agent;
      this.debug('queuer_login', source);
      agent = new Agent(source);
      await agent.set('name', name);
      await agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.add_tag(`queue:${fifo.full_name}`);
      }
      // * doc.local_number.login_commands: (optional) array of ornaments, applied when a call-center agent logs into the system.
      if (ornaments != null) {
        this.agent = agent;
        await run.call(this, ornaments, this.ornaments_commands);
      }
      await agent.accept_onhook();
      await this.report({
        state: 'queuer-login',
        source,
        fifo,
        tags
      });
      return agent;
    };
    this.queuer_leave = async function(source, fifo) {
      var agent;
      this.debug('queuer_leave', source);
      agent = new Agent(source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.del_tag(`queue:${fifo.full_name}`);
      }
      await this.report({
        state: 'queuer-leave',
        source,
        fifo
      });
      return agent;
    };
    this.queuer_logout = async function(source, fifo) {
      var agent;
      this.debug('queuer_logout', source);
      agent = new Agent(source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.del_tag(`queue:${fifo.full_name}`);
      }
      await agent.clear_tags();
      await agent.transition('logout');
      await this.report({
        state: 'queuer-logout',
        source,
        fifo
      });
      return agent;
    };
    // Off-hook agent
    // --------------
    return this.queuer_offhook = async function(source, name, {uuid}, fifo, tags = []) {
      var agent, call;
      this.debug('queuer_offhook', source, uuid, fifo);
      agent = new Agent(source);
      await agent.set('name', name);
      agent.clear_tags();
      await agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.add_tag(`queue:${fifo.full_name}`);
      }
      call = (await agent.accept_offhook(uuid));
      if (call == null) {
        return;
      }
      await call.set_session(this.session._id);
      await this.report({
        state: 'queuer-offhook',
        source,
        fifo,
        tags
      });
      return agent;
    };
  };

}).call(this);
