// Generated by CoffeeScript 2.3.1
(function() {
  var EventEmitter2, FS, LRU, Moment, RedRingAxon, Redis, RedisInterface, Reference, assert, debug, default_wrapper, foot, minutes, nimble, now, pkg, seconds,
    indexOf = [].indexOf,
    hasProp = {}.hasOwnProperty;

  nimble = require('nimble-direction');

  pkg = require('../package.json');

  ({EventEmitter2} = require('eventemitter2'));

  Moment = require('moment-timezone');

  this.name = `${pkg.name}:middleware:setup`;

  assert = require('assert');

  FS = require('esl');

  LRU = require('lru-cache');

  RedRingAxon = require('red-rings-axon');

  Redis = require('ioredis');

  RedisInterface = require('normal-key/interface');

  Reference = require('./reference');

  ({debug, foot} = (require('tangible'))(this.name));

  seconds = 1000;

  minutes = 60 * seconds;

  now = function(tz = 'UTC') {
    return Moment().tz(tz).format();
  };

  default_wrapper = null;

  this.end = function() {
    default_wrapper.end();
    this.cfg.global_redis_client.end();
    if (this.cfg.local_redis_client !== this.cfg.global_redis_client) {
      return this.cfg.local_redis_client.end();
    }
  };

  this.config = async function() {
    await nimble(this.cfg);
    return assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
  };

  this.server_pre = async function() {
    var HugePlayReference, _api, _wrapper, base, call_timeout, is_remote_cache, make_a_redis, redis_interface, ref;
    // Red-Rings Axon connexion
    this.cfg.rr = new RedRingAxon((ref = this.cfg.axon) != null ? ref : {});
    await nimble(this.cfg);
    assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
    // Local and Global Redis
    // ----------------------
    make_a_redis = (label, config) => {
      var a_redis;
      a_redis = Redis.createClient(config);
      a_redis.on('error', (error) => {
        var ref1, ref2;
        return debug(`${label}: ${error.command} ${(ref1 = error.args) != null ? ref1.join(' ') : void 0}: ${(ref2 = error.stack) != null ? ref2 : error}`);
      });
      a_redis.on('ready', () => {
        return debug(`${label}: ready`);
      });
      a_redis.on('connect', () => {
        return debug(`${label}: connect`);
      });
      a_redis.on('reconnecting', () => {
        return debug(`${label}: reconnecting`);
      });
      a_redis.on('end', () => {
        return debug(`${label}: end`);
      });
      a_redis.on('warning', () => {
        return debug(`${label}: warning`);
      });
      return a_redis;
    };
    assert(this.cfg.redis != null, 'cfg.redis (global redis) is required for Reference');
    // * @cfg.redis (Required) Configuration for a global redis server shared by all instances.
    this.cfg.global_redis_client = make_a_redis('global redis', this.cfg.redis);
    // * @cfg.local_redis (Optional, recommended) If present, used as the configuration for a local redis server. Default: use the global redis server defined in @cfg.redis
    if (this.cfg.local_redis != null) {
      this.cfg.local_redis_client = make_a_redis('local redis', this.cfg.local_redis);
    } else {
      this.cfg.local_redis_client = this.cfg.global_redis_client;
    }
    // How long should we keep a reference after the last update?
    call_timeout = 8 * 3600;
    redis_interface = new RedisInterface(this.cfg.global_redis_client, call_timeout);
    HugePlayReference = (function() {
      class HugePlayReference extends Reference {};

      HugePlayReference.prototype.interface = redis_interface;

      return HugePlayReference;

    }).call(this);
    this.cfg.Reference = HugePlayReference;
    // Period
    // ------

    // Used by billing code.
    if ((base = this.cfg).period_of == null) {
      base.period_of = function(stamp = new Date(), timezone = 'UTC') {
        return Moment.tz(stamp, timezone).format('YYYY-MM');
      };
    }
    // Is-remote Cache
    // ---------------

    // Use redis to retrieve the server on which this call should be hosted, and set it to `local_server` if none was previously set.
    // Returns either:
    // - `false` to indicate the call should be handled locally;
    // - the value previously stored if it is available;
    // - `null` if the determination could not be made (for example due to parameter, configuration, or server error).

    // If the `local_server` parameter is not provided (it normally should), only the previously stored value is checked. This should never be used when dealing with calls, since it means the call might not go through.
    is_remote_cache = LRU({
      max: 2000,
      maxAge: 1 * minutes
    });
    this.cfg.is_remote = async(name, local_server) => {
      var first_time, key, server;
      if (name == null) {
        return null;
      }
      key = `server for ${name}`;
      if (this.cfg.global_redis_client == null) {
        debug.dev('is_remote: Missing global redis');
        return null;
      }
      // Just probing (this is only useful when retrieving data, never when handling calls).
      if (local_server == null) {
        server = is_remote_cache.get(name);
        if (server === void 0) {
          server = (await this.cfg.global_redis_client.get(key).catch(function(error) {
            var ref1;
            debug.ops(`error ${(ref1 = error.stack) != null ? ref1 : error}`);
            return null;
          }));
          is_remote_cache.set(name, server);
        }
        switch (server != null ? server.substring(0, this.cfg.host.length) : void 0) {
          case null:
            return null;
          case this.cfg.host:
            return false;
          default:
            return server;
        }
      }
      // Probe-and-update
      server = local_server;
      // Set if not exists, [setnx](https://redis.io/commands/setnx)
      // (Note: there's also hsetnx/hget which could be used for this, not sure what's best practices.)
      first_time = (await this.cfg.global_redis_client.setnx(key, server).catch(function(error) {
        var ref1;
        debug.ops(`error ${(ref1 = error.stack) != null ? ref1 : error}, forcing local server`);
        return 1;
      }));
      if (!first_time) {
        server = (await this.cfg.global_redis_client.get(key).catch(function(error) {
          var ref1;
          debug.ops(`error ${(ref1 = error.stack) != null ? ref1 : error}`);
          return null;
        }));
      }
      // Check whether handling is local (assuming FreeSwitch is co-hosted, which is our standard assumption).
      debug('Checking for local handling', server, local_server);
      switch (server) {
        case null:
          debug.ops('Redis failed');
          return null;
        case local_server:
          debug('Handling is local');
          return false;
        default:
          debug('Handling is remote');
          return server;
      }
    };
    // FreeSwitch API Client
    // ---------------------

    // These methods parallel the ones in black-metal/api.
    // Eventually the two should be merged.

    // Create a new socket client
    _wrapper = () => {
      var options, ref1, ref2;
      options = {
        host: (ref1 = this.cfg.socket_host) != null ? ref1 : '127.0.0.1',
        port: (ref2 = this.cfg.socket_port) != null ? ref2 : 5722
      };
      return FS.createClient(options);
    };
    // Use a default client for generic / shared APIs
    default_wrapper = (await _wrapper());
    _api = async function(cmd) {
      var res;
      return res = (await default_wrapper.client.bgapi(cmd));
    };
    // * cfg.api(command) returns (a Promise for) the body of the response for a FreeSwitch `api` command.
    this.cfg.api = async(cmd) => {
      var ref1, res;
      debug('api', cmd);
      res = (await _api(cmd));
      return (ref1 = res != null ? res.body : void 0) != null ? ref1 : null;
    };
    // * cfg.api.send(command) returns (a Promise for) the `esl` response to the command.
    this.cfg.api.send = _api;
    // * cfg.api.truthy(command) returns (a Promise for) a boolean indicating the success of the command.
    this.cfg.api.truthy = (cmd) => {
      var on_failure, on_success;
      debug('api.truthy', cmd);
      on_success = function(res) {
        debug('api.truthy', cmd, res);
        switch (false) {
          case res.uuid == null:
            return res.uuid;
          case res.body !== 'true':
            return true;
          case res.body !== 'false':
            return false;
          case res.body[0] !== '-':
            return false;
          default:
            return true;
        }
      };
      on_failure = function(error) {
        debug('api.truthy', cmd, error);
        return false;
      };
      return _api(cmd).then(on_success, on_failure);
    };
  };

  // Web
  // ---
  this.web = function() {
    return this.cfg.versions[pkg.name] = pkg.version;
  };

  // Inbound notifications
  // ---------------------

  // This entire section is DEPRECATED.
  this.notify = function() {
    this.on_connexion = (init) => {
      // Run on re-connections (`welcome` is sent by spicy-action when we connect).
      this.socket.on('welcome', init);
      // Run manually when we start (the `welcome` message has probably already been seen).
      return init();
    };
    // Register a new event on the bus.
    this.register = (event, default_room = null) => {
      return this.on_connexion(() => {
        debug('Register', {event, default_room});
        return this.socket.emit('register', {event, default_room});
      });
    };
    // Configure our client to receive specific queues.
    this.socket.on('configured', (data) => {
      return debug('Socket configured', data);
    });
    this.configure = (options) => {
      return this.on_connexion(() => {
        debug('Configure', options);
        return this.socket.emit('configure', options);
      });
    };
    this.socket.on('connect', () => {
      return debug.ops('connect');
    });
    this.socket.on('connect_error', () => {
      return debug.ops('connect_error');
    });
    this.socket.on('disconnect', () => {
      return debug.ops('disconnect');
    });
  };

  // Context Extension
  // -----------------
  this.include = function(ctx) {
    var _bus, k, ref, v;
    _bus = new EventEmitter2();
    ref = {
      on: function(ev, cb) {
        return _bus.on(ev, cb);
      },
      once: function(ev, cb) {
        return _bus.once(ev, cb);
      },
      emit: function(ev, data) {
        return _bus.emit(ev, data);
      },
      end: function() {
        _bus.removeAllListeners();
        this.call = null;
        this.session = null;
        this.reference = null;
      },
      statistics: this.cfg.statistics,
      sleep: function(timeout) {
        return new Promise(function(resolve) {
          return setTimeout(resolve, timeout);
        });
      },
      direction: function(direction) {
        this.session.direction = direction;
        this.emit('direction', direction);
        return this.report({
          event: 'direction',
          direction
        });
      },
      _in: async function(_in = []) {
        var i, len, push_in, ref, ref1, ref2, ref3, ref4, ref5, tag, tags;
        push_in = function(room) {
          if ((room == null) || indexOf.call(_in, room) >= 0) {
            return;
          }
          return _in.push(room);
        };
        push_in((ref = this.session.endpoint) != null ? ref._id : void 0);
        if (((ref1 = this.session.number) != null ? ref1.endpoint : void 0) != null) {
          push_in(['endpoint', (ref2 = this.session.number) != null ? ref2.endpoint : void 0].join(':'));
        }
        push_in((ref3 = this.session.number) != null ? ref3._id : void 0);
        push_in((ref4 = this.session.e164_number) != null ? ref4._id : void 0);
        if (((ref5 = this.session.number_domain_data) != null ? ref5.dialplan : void 0) === 'centrex') {
          push_in(this.session.number_domain_data._id);
        }
        if (this.reference != null) {
          tags = (await this.reference.get_in().catch(function() {
            return [];
          }));
          for (i = 0, len = tags.length; i < len; i++) {
            tag = tags[i];
            push_in(tag);
          }
        }
        return _in;
      },
      report: async function(report) {
        var ref;
        if (!((this.call != null) && (this.session != null))) {
          debug.dev('report: improper environment');
          return false;
        }
        if (report.old_state == null) {
          report.old_state = this.session.state;
        }
        if (report.state != null) {
          this.session.state = report.state;
        }
        if (report.timezone == null) {
          report.timezone = this.session.timezone;
        }
        if (report.timestamp == null) {
          report.timestamp = now(report.timezone);
        }
        report.now = Date.now();
        report._in = (await this._in(report._in));
        if (report.host == null) {
          report.host = this.cfg.host;
        }
        if (report.type == null) {
          report.type = 'report';
        }
        if (report.source == null) {
          report.source = this.source;
        }
        if (report.destination == null) {
          report.destination = this.destination;
        }
        if (report.direction == null) {
          report.direction = this.session.direction;
        }
        if (report.dialplan == null) {
          report.dialplan = this.session.dialplan;
        }
        if (report.country == null) {
          report.country = this.session.country;
        }
        if (report.number_domain == null) {
          report.number_domain = this.session.number_domain;
        }
        if (report.number_domain_dialplan == null) {
          report.number_domain_dialplan = (ref = this.session.number_domain_data) != null ? ref.dialplan : void 0;
        }
        if (report.agent == null) {
          report.agent = this.session.agent;
        }
        if (report.agent_name == null) {
          report.agent_name = this.session.agent_name;
        }
        report.call = this.call.uuid;
        report.session = this.session._id;
        report.reference = this.session.reference;
        report.report_type = 'in-call';
        this.cfg.statistics.emit('report', report);
        if (report.agent != null) {
          this.cfg.rr.notify(`agent:${report.agent}`, `call:${report.call}`, report);
        }
        if (report.endpoint != null) {
          this.cfg.rr.notify(`endpoint:${report.endpoint}`, `call:${report.call}`, report);
        }
        return true;
      },
      notify: function(report) {
        report._notify = true;
        return this.report(report);
      },
      set: async function(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.set(name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          await this.res.set(k, v);
        }
      },
      unset: async function(name) {
        var i, len;
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.set(name, null);
          return;
        }
        for (i = 0, len = name.length; i < len; i++) {
          k = name[i];
          await this.res.set(k, null);
        }
      },
      export: async function(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          await this.res.export(name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          await this.res.export(k, v);
        }
      },
      respond: function(response) {
        var base, ref;
        if ((ref = this.statistics) != null) {
          ref.add(['immediate-response', response]);
        }
        this.notify({
          state: 'immediate-response',
          response: response
        });
        if ((base = this.session).first_response_was == null) {
          base.first_response_was = response;
        }
        this.direction('responded');
        if (this.session.alternate_response != null) {
          return this.session.alternate_response(response);
        } else {
          return ctx.action('respond', response);
        }
      },
      sofia_string: async function(number, extra_params = []) {
        var destination, id, number_data, params, to_uri;
        debug('sofia_string', number, extra_params);
        id = `number:${number}@${this.session.number_domain}`;
        number_data = (await this.cfg.prov.get(id).catch(function(error) {
          var ref;
          debug.ops(`${id} ${(ref = error.stack) != null ? ref : error}`);
          return {};
        }));
        if (number_data.number == null) {
          return '';
        }
        destination = number_data.number.split('@')[0];
        to_uri = `sip:${number_data.endpoint}`;
        if (!to_uri.match(/@/)) {
          to_uri = `sip:${destination}@${this.cfg.ingress_target}`;
        }
        if (number_data.endpoint_via != null) {
          extra_params.push(`sip_network_destination=${number_data.endpoint_via}`);
        }
        params = [...extra_params, `sip_h_X-En=${number_data.endpoint}`];
        return `[${params.join(',')}]sofia/${this.session.sip_profile}/${to_uri}`;
      },
      validate_local_number: async function() {
        var base, base1, dst_number;
        dst_number = `${this.destination}@${this.session.number_domain}`;
        this.session.number = (await this.cfg.prov.get(`number:${dst_number}`).catch(function(error) {
          return {
            disabled: true,
            error
          };
        }));
        await this.reference.add_in(this.session.number._id);
        await this.user_tags(this.session.number.tags);
        if (this.session.number.timezone != null) {
          if ((base = this.session).timezone == null) {
            base.timezone = this.session.number.timezone;
          }
        }
        if (this.session.number.music != null) {
          if ((base1 = this.session).music == null) {
            base1.music = this.session.number.music;
          }
        }
        if (this.session.number.error != null) {
          this.debug.dev(`Could not locate destination number ${dst_number}`);
          this.notify({
            state: 'invalid-local-number',
            number: this.session.number._id
          });
          await this.respond('486 Not Found');
          return;
        }
        this.debug(`validate_local_number: Got dst_number ${dst_number}`, this.session.number);
        if (this.session.number.disabled) {
          this.debug.ops(`Number ${dst_number} is disabled`);
          this.notify({
            state: 'disabled-local-number',
            number: this.session.number._id
          });
          await this.respond('486 Administratively Forbidden');
          return;
        }
        this.session.endpoint_name = this.session.number.endpoint;
        await this.reference.set_endpoint(this.session.number.endpoint);
        await this.reference.add_in(`endpoint:${this.session.number.endpoint}`);
        await this.reference.set_account(this.session.number.account);
        await this.reference.add_in(`account:${this.session.number.account}`);
        this.report({
          state: 'validated-local-number',
          number: this.session.number._id,
          endpoint: this.session.endpoint_name,
          account: this.session.number.account
        });
        return dst_number;
      },
      global_redis: this.cfg.global_redis_client,
      local_redis: this.cfg.local_redis_client,
      tag: async function(tag) {
        if (tag != null) {
          await this.reference.add_tag(tag);
          return this.report({
            event: 'tag',
            tag
          });
        }
      },
      user_tag: async function(tag) {
        if (tag != null) {
          await this.reference.add_tag(`user-tag:${tag}`);
          return this.report({
            event: 'user-tag',
            tag
          });
        }
      },
      user_tags: async function(tags) {
        var i, len, results, tag;
        if (tags == null) {
          return;
        }
        results = [];
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          results.push((await this.user_tag(tag)));
        }
        return results;
      },
      has_tag: async function(tag) {
        return (tag != null) && (await this.reference.has_tag(tag));
      },
      has_user_tag: async function(tag) {
        return (tag != null) && (await this.has_tag(`user-tag:${tag}`));
      },
      clear_call_center_tags: async function() {
        var i, len, tag, tags;
        tags = (await this.reference.tags());
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          if (tag === 'broadcast' || tag.match(/^(skill|priority|queue):/)) {
            await this.reference.del_tag(tag);
          }
        }
        return null;
      },
      clear_user_tags: async function() {
        var i, len, tag, tags;
        tags = (await this.reference.tags());
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          if (tag.match(/^user-tag:/)) {
            await this.reference.del_tag(tag);
          }
        }
        return null;
      },
      record_call: function(name) {
        var keep_recording;
        if (this.cfg.recording_uri == null) {
          this.debug.dev('No recording_uri, call will not be recorded.');
          return false;
        }
        keep_recording = async() => {
          var last_uri, outcome, still_running, uri;
          this.report({
            event: 'recording'
          });
          uri = (await this.cfg.recording_uri(name));
          this.debug('Recording', this.call.uuid, uri);
          outcome = (await this.cfg.api(`uuid_record ${this.call.uuid} start ${uri}`));
          this.debug('Recording', this.call.uuid, uri, outcome);
          last_uri = uri;
          still_running = true;
          this.call.once('CHANNEL_HANGUP_COMPLETE', function() {
            return still_running = false;
          });
          while (still_running) {
            await this.sleep(29 * minutes);
            uri = (await this.cfg.recording_uri(name));
            this.debug('Recording next segment', this.call.uuid, uri);
            await this.cfg.api(`uuid_record ${this.call.uuid} start ${uri}`);
            this.report({
              event: 'recording'
            });
            await this.sleep(1 * minutes);
            this.debug('Stopping previous segment', this.call.uuid, last_uri);
            await this.cfg.api(`uuid_record ${this.call.uuid} stop ${last_uri}`);
            last_uri = uri;
          }
        };
        keep_recording().catch((error) => {
          var ref;
          return this.debug(`record_call: ${(ref = error.stack) != null ? ref : error}`);
        });
        this.debug('Going to record', name);
        return true;
      }
    };
    // `@_in()`: Build a list of target rooms for event reporting (as used by spicy-action).
    // Add any endpoint- or number- specific dispatch room (this allows end-users to receive events for endpoints and numbers they are authorized to monitor).
    // We assume the room names match record IDs.
    // Data reporting (e.g. to save for managers reports).
    // Typically `@report({state,…})` for calls state changes / progress, `@report({event,…})` for non-calls.
    // This version is meant to be used in-call.
    // Real-time notification (e.g. to show on a web panel).
    // Prevent extraneous processing of this call.
    // This is a simplified version of the sofia-target (session.initial_destinations) building code found in middleware:client:ingress:post.
    // This is a simplified version of the sofia-string building code found in middleware:client:ingress:send.

    // * hdr.X-En Endpoint name, set when dialing numbers.
    // Retrieve number data.

    // * session.number (object) The record of the destination number interpreted as a local-number in `session.number_domain`.
    // * doc.local_number.disabled (boolean) If true the record is not used.
    // was 403
    // Set the endpoint name so that if we redirect to voicemail the voicemail module can locate the endpoint.
    // Set the account so that if we redirect to an external number the egress module can find it.
    // Keep recording (async)
    for (k in ref) {
      if (!hasProp.call(ref, k)) continue;
      v = ref[k];
      ctx[k] = v;
    }
  };

}).call(this);
